# 重合公式（1変数関数の積分：台形公式）

# 積分関数の定義
f<-function(x){
  z=exp(x)
  return(z)
}

# 1区間単位の大きさ
h=0.01

# 積分区間（終点）
end_point=0.4

# 積分区間（始点）
start_point=0

# f0,f1,f2,...を作るデータフレーム
f_data=data.frame(x=seq(start_point,end_point,h),f=0)
for(j in 1:nrow(f_data)){
  f_data$f[j]=f(f_data$x[j])
}

# 重合公式の計算
integrated_f=c()
for(j in 1:nrow(f_data)){
  if(j==1|j==nrow(f_data)){
    integrated_f=c(integrated_f,f_data$f[j])
  }else{
    integrated_f=c(integrated_f,2*f_data$f[j]) 
  }
}

integrated_f=(h/2)*integrated_f

# 補正項がない場合の積分値
print(paste0("区間",start_point,"から",end_point,"までの積分値は",sum(integrated_f)))

# Rのライブラリ使用
print(paste0("実際の値は",integrate(f,start_point,end_point)$value))
