# 多重積分

# 2重積分（シンプソンの第一公式）

# 積分区間：x軸
x1=0;x2=1

# 積分区間：y軸
y1=1;y2=2

# h,k幅の指定
h=0.01;k=0.01

# 関数定義
f=function(x,y){
  z<-1/(x+y)
  return(z)
}

# Y軸:k幅
Y=seq(y1,y2,k)

# X軸:h幅
X=seq(x1,x2,h)

lattice1=array(4,dim=c(length(X),length(Y)))
lattice2=array(0,dim=c(length(X),length(Y)))
coefficient1=c(1);coefficient2=c(4);coefficient3=c(2) 
for(j in 2:(length(X)-1)){
  coefficient1=c(coefficient1,ifelse(j/2==floor(j/2),4,2)) 
  coefficient2=c(coefficient2,ifelse(j/2==floor(j/2),16,8)) 
  coefficient3=c(coefficient3,ifelse(j/2==floor(j/2),8,4)) 
}

# 1番最初の行の係数列
coefficient1=c(coefficient1,1);

# 偶数番目の行の係数列
coefficient2=c(coefficient2,4);

# 奇数番目の行の係数列
coefficient3=c(coefficient3,2);

lattice1=t(lattice1)
for(j in 1:nrow(lattice1)){
  if(j==1|j==nrow(lattice1)){
    lattice1[j,]=coefficient1
  }else{
    if(j/2==floor(j/2)){
      lattice1[j,]=coefficient2
    }else{
      lattice1[j,]=coefficient3
    }
  }
}

for(j in 1:length(X)){
  for(i in 1:length(Y)){
    lattice2[j,i]=f(X[j],Y[i])
  }
}

lattice1=t(lattice1)
print(paste0("重積分の値は",sum((1/9)*h*k*lattice1*lattice2)))
