# ポアソン分布の対数尤度を勾配上昇法を用いて最大化する

# 観測データを作成
x=c(3,5,4,2,7)

# 対数尤度関数を設定
loglik<-function(lam){
  return(sum(x)*log(lam)-length(x)*lam-sum(log(factorial(x))))
}

# パラメータ初期値
mu=1

# 反復計算回数
ite=1000

# 学習率
eta=0.01

# 差分メッシュ
h=0.01

for(l in 1:ite){
  # パラメータを前進差分（数値微分）で更新
  mu=mu+eta*(loglik(mu+h)-loglik(mu))/h

  # 対数尤度関数の値をプロット
  print(loglik(mu))
}

# 反復計算で求められたパラメータ値
mu

# 実際の最尤推定量
mean(x)
