# 2dim-newton method

# データxが標準正規分布に従う場合のパラメータを計算
x=rnorm(100)

# 関数定義f：f(μ,σ^2)
f<-function(z){
  return(sum(x)-length(x)*z[1])
}

# 関数定義g：g(μ,σ^2)
g<-function(z){
  return(sum((x-z[1])^2)-length(x)*z[2])
}

# 初期値：μ=1.5、σ^2=1.5
A=t(t(rep(1.5,2)))

# 反復回数
times=10000

# 差分メッシュ
h=0.01

# 学習率
eta=0.001

for(j in 1:times){
  df=c();dg=c()
  for(l in 1:length(A)){
    vec=A;vec[l]=vec[l]+h
    df=c(df,(f(vec)-f(A))/h)
    dg=c(dg,(g(vec)-g(A))/h)
 }

  # 1次勾配で作成した行列
  H=t(matrix(c(df,dg),ncol=2,nrow=2))

  # 更新
  A=A-eta*solve(H)%*%c(f(A),g(A))

  print(A)
}
