# pre-Broyden Algorithm

# 関数定義
f<-function(x){
  f1=x[1]^2+x[2]^2-1
  f2=x[1]^2-x[2]^2+0.5
  return(c(f1,f2))
}

# 初期値
X=c(1,2)

# 差分メッシュ
h=0.01

# ヤコビアンの近似行列の初期値
B=diag((f(X+h)-f(X))/h)

# 反復計算回数
ite=100

for(l in 1:ite){
  # 計算打ち止め条件：すべての非線形関数の絶対値の和が10^(-9)以下になったら計算終了
  if(sum(abs(f(X)))>10^(-9)){
    # 以前の座標点を保存
    X_pre=X

    # 座標点を更新
    X=X-solve(B)%*%f(X)

    # 以前の座標点と更新された座標点の差のベクトル(s)
    s=X-X_pre

    # 以前の座標点と更新された座標点の関数値の差のベクトル(y)
    y=f(X)-f(X_pre)

    # ヤコビアンの近似行列を更新する
    B=B+((y-B%*%s)/as.numeric(t(s)%*%s))%*%t(s)

    print(f(X))
  }
}
