# 野球のデータ（回帰分析の基礎 p.55）
data=data.frame(players=c("掛布","岡田","真弓","杉浦","原","クロマティ","レオン","衣笠","山本"),y=c(0.084,0.0762,0.0684,0.0847,0.0771,0.0663,0.067,0.0583,0.0628),x1=c(0.1675,0.1259,0.1023,0.16,0.1343,0.0648,0.141,0.0907,0.1565),x2=c(0.1302,0.0892,0.1046,0.1072,0.0952,0.1058,0.1666,0.1604,0.1439))

# 特徴量行列（四球/打席数：x1, 三振/打数：x2）
X=cbind(rep(1,nrow(data)),data$x1,data$x2)

# 目的変量（本塁打/打数：y）
y=data$y

# 偏回帰係数
beta=solve(t(X)%*%X)%*%t(X)%*%y

# 回帰推定値
Y_hat=X%*%beta

# 残差変動
Se=sum((Y_hat-y)^2)

# 回帰変動
Sr=sum((Y_hat-mean(Y_hat))^2)

# 全変動
Syy=Se+Sr

# 寄与率
R2=Sr/Syy

# 重相関係数
R=sqrt(R2)

# 誤差分散の不偏推定量
sigma_hat=sqrt(Se/(nrow(data)-3))

# 偏差積和行列Aの計算
X2=X[,-1];x_ave=apply(X2,2,mean)
X2=t(t(X2)-apply(X2,2,mean))
A=t(X2)%*%X2

# 偏差積和行列の逆行列
inv_A=solve(A)

# 切片・傾きの信頼区間の計算
sigma0=sqrt(1/nrow(data)+sum((t(t(x_ave))%*%t(x_ave))*inv_A))*sigma_hat
sigma1=sqrt(diag(inv_A))[1]*sigma_hat
sigma2=sqrt(diag(inv_A))[2]*sigma_hat

print(paste0("切片の信頼区間は両側５％で",beta[1]-qt(1-0.05/2,df=nrow(data)-3)*sigma0," ~ ",beta[1]+qt(1-0.05/2,df=nrow(data)-3)*sigma0))
print(paste0("偏回帰係数(x1)の信頼区間は両側5％で",beta[2]-qt(1-0.05/2,df=nrow(data)-3)*sigma1," ~ ",beta[2]+qt(1-0.05/2,df=nrow(data)-3)*sigma1))
print(paste0("偏回帰係数(x2)の信頼区間は両側5％で",beta[3]-qt(1-0.05/2,df=nrow(data)-3)*sigma2," ~ ",beta[3]+qt(1-0.05/2,df=nrow(data)-3)*sigma2))
