# Bradley-Terry model

# サンプルデータの作成（野球の試合のデータ）
dat1=array(0,dim=c(6,6))

dat1[1,]=c(0,14,12,18,15,14)
dat1[2,]=c(11,0,13,18,17,16)
dat1[3,]=c(8,11,0,9,16,16)
dat1[4,]=c(7,7,16,0,11,15)
dat1[5,]=c(8,7,10,13,0,16)
dat1[6,]=c(12,9,9,11,8,0)

rownames(dat1)=c("広島","巨人","阪神","大洋","中日","ヤクルト")
colnames(dat1)=c("広島","巨人","阪神","大洋","中日","ヤクルト")

# 総試合数のデータ
nij=array(0,dim=c(6,6))

for(i in 1:6){
  for(j in 1:6){
    nij[i,j]=dat1[i,j]+dat1[j,i]
  }
}

# 勝数
t=apply(dat1,1,sum)

# 各チームの強さの平均が50になるようにする
k=300

# パラメータの初期値
pi=k*rep(1/6,6)

# 反復計算回数
ite=100

for(l in 1:ite){
  # 以前のパラメータを保存
  pi_pre=pi
  r=c()

  for(i in 1:length(pi)){
    pi_sub=pi[-i]
    ri=sum(nij[i,-i]/(pi[i]+pi_sub))
    r=c(r,ri)
  }

  pi_sub=t/r

  # パラメータの更新
  pi=k*pi_sub/sum(pi_sub)
  pi_mat=array(0,dim=c(length(pi),length(pi)))

  for(i in 1:length(pi)){
    pi_mat[i,]=pi[i]+pi
  }

  diag(pi_mat)=1
  l_sub=as.matrix(nij)*log(pi_mat)
  l_sub=sum(l_sub)/2

  # 対数尤度
  l=sum(t*log(pi))-l_sub

  print(l)
}

pij=array(0,dim=c(length(pi),length(pi)))

for(j in 1:length(pi)){
  pij[j,-j]=pi[j]/(pi[j]+pi[-j])
}

# BTモデルの検定（尤度比検定）
l0=dat1*log(dat1);diag(l0)=0
l0=sum(l0)-sum((nij*log(nij))[upper.tri(nij*log(nij))])

# 帰無仮説　モデルの精度の検定-BTモデルがなりたっているか
kai=2*(l0-l)
v=(length(pi)-1)*(length(pi)-2)/2
qchisq(1-0.05,df=v)

# H:pi=一定
l2=-sum(nij[upper.tri(nij)]*log(2))
v=(length(pi)-1)
kai2=2*(l-l2)
qchisq(1-0.05,v)

# 表2.4
aij=array(0,dim=c(length(pi), length(pi)))
for(i in 1: length(pi)){
  for(j in 1: length(pi)){
    aij[i,j]=log2(((dat1[i,j]+0.5)*pi[j])/((dat1[j,i]+0.5)*pi[i]))
  }
}

mu2=eigen(t(aij)%*%aij)$values
v=eigen(t(aij)%*%aij)$vectors
u=t(t(aij%*%v)/sqrt(mu2))
