# Bradley-Terry model

dat1=array(0,dim=c(6,6))
dat1[1,]=c(0,14,12,18,15,14)
dat1[2,]=c(11,0,13,18,17,16)
dat1[3,]=c(8,11,0,9,16,16)
dat1[4,]=c(7,7,16,0,11,15)
dat1[5,]=c(8,7,10,13,0,16)
dat1[6,]=c(12,9,9,11,8,0)

nij=array(0,dim=c(6,6))
for(i in 1:6){
  for(j in 1:6){
    nij[i,j]=dat1[i,j]+dat1[j,i]
  }
}

t=apply(dat1,1,sum)
k=300

# Broyden Quasi-Newton Algorithm

# 関数定義（最尤方程式）
f<-function(x){
  pi=x
  f1=c()
  for(i in 1:length(x)){
    f1=c(f1,t[i]/pi[i]-sum(nij[i,-i]/(pi[i]+pi[-i])))
  }
  return(c(f1))
}

X=k*rep(1/6,6)
ite=10000
eta=0.001
H=diag(f(X))

for(l in 1:ite){
  if(sum(abs(f(X)))>10^(-9)){
    X_pre=X
    X=X-eta*H%*%f(X)
    X=k*X/sum(X)
    s=X-X_pre
    y=f(X)-f(X_pre)
    H=H+((s-H%*%y)/as.numeric(t(s)%*%H%*%y))%*%t(s)%*%H
    print(sum(abs(f(X))))
  }
}
