# Bradley-Terry model

dat1=array(0,dim=c(6,6))

dat1[1,]=c(0,14,12,18,15,14)
dat1[2,]=c(11,0,13,18,17,16)
dat1[3,]=c(8,11,0,9,16,16)
dat1[4,]=c(7,7,16,0,11,15)
dat1[5,]=c(8,7,10,13,0,16)
dat1[6,]=c(12,9,9,11,8,0)

nij=array(0,dim=c(6,6))
for(i in 1:6){
  for(j in 1:6){
    nij[i,j]=dat1[i,j]+dat1[j,i]
  }
}

t=apply(dat1,1,sum)
k=300

# fiacco, mccormick(1968), murtagh, sargent(1969)

# 関数定義
f=function(x){
  pi=x
  f1=c()
  for(i in 1:length(x)){
    f1=c(f1,t[i]/pi[i]-sum(nij[i,-i]/(pi[i]+pi[-i])))
  }
  return(c(f1))
}

# 初期値
X=k*rep(1/6,6)

# ヘッシアンの近似行列の初期値
H=diag(1,length(X))

# 反復計算回数
ite=100000

# 最小点から非常にかけ離れた点になるのを防ぐためのスカラ
eta=10^(-2)

for(l in 1:ite){
  # 各代数方程式の値が入ったベクトル
  f_val=f(X)

  # 座標点に対する更新量ベクトル
  sigma=t(t(-H%*%f_val))

  # etaによって学習幅を設定し座標点を更新
  X=X+eta*sigma
  X=k*X/sum(X)

  #以前の座標点と更新された座標点の関数値の差のベクトル(y)
  y=f(X)-f_val

  # ヘッシアンの逆行列の近似行列の更新
  H=H+(eta*sigma-H%*%y)%*%t(eta*sigma-H%*%y)/as.numeric(t(y)%*%(eta*sigma-H%*%y))

  print(f(X))
}
