# Bradley-Terry model

dat1=array(0,dim=c(6,6))

dat1[1,]=c(0,14,12,18,15,14)
dat1[2,]=c(11,0,13,18,17,16)
dat1[3,]=c(8,11,0,9,16,16)
dat1[4,]=c(7,7,16,0,11,15)
dat1[5,]=c(8,7,10,13,0,16)
dat1[6,]=c(12,9,9,11,8,0)

nij=array(0,dim=c(6,6))
for(i in 1:6){
  for(j in 1:6){
    nij[i,j]=dat1[i,j]+dat1[j,i]
  }
}

t=apply(dat1,1,sum)
k=300

# levenberg(1944)

# 関数定義
f=function(x){
  pi=x
  f1=c()
  for(i in 1:length(x)){
    f1=c(f1,t[i]/pi[i]-sum(nij[i,-i]/(pi[i]+pi[-i])))
  }
  return(c(f1))
}

# 初期値
X=k*rep(1/6,6)

# 反復計算回数
ite=100000

# 学習率
eta=10^(-2)

# 差分メッシュ
h=0.01

# 正の小さいスカラ
w=0.01

for(l in 1:ite){
  # ヤコビアンを計算する箱を用意
  df=array(0,dim=c(length(X),length(X)))

  # 1次差分を用いて数値微分し、ヤコビアンを計算する
  for(j in 1:length(X)){
    vec=X;vec[j]=vec[j]+h
    df[j,]=(f(vec)-f(X))/h
  }

  # 逆行列が特異にならないよう、対角成分をwで調整
  A=df%*%t(df)+diag(w,length(X))
  y=df%*%f(X)

  # 座標点更新の際に必要なベクトルを計算
  dx=solve(A)%*%(-y)

  # 学習幅に従って座標点を更新
  X=X+eta*dx
  X=k*X/sum(X)

  print(f(X))
}
