# 母親の総数
rij=matrix(c(102,64,67,46,49,37),ncol=3)

# 以前出産事故のあった母親の総数
nij=matrix(c(20,10,26,16,27,14),ncol=3)

a=nrow(rij);b=ncol(rij)

f=function(x){
  mu=x[1];x=x[-1]
  alpha=x[1:a];x=x[-c(1:a)];
  beta=x;
  mat_ab=array(0,dim=c(a,b))
  for(i in 1:a){
    for(j in 1:b){
      mat_ab[i,j]=rij[i,j]*exp(mu+alpha[i]+beta[j])/(1+exp(mu+alpha[i]+beta[j]))
    }
  }

  mat_a=-apply(mat_ab,1,sum)+apply(nij,1,sum)
  mat_a[length(mat_a)]=0
  mat_b=-apply(mat_ab,2,sum)+apply(nij,2,sum)
  mat_b[length(mat_b)]=0
  mat_ab=-sum(mat_ab)+sum(nij)
  return(c(mat_ab,mat_a,mat_b))
}

# fiacco, mccormick(1968), murtagh, sargent(1969)

# 初期値
X=rep(0,a+b+1)

# ヘッシアンの近似行列の初期値
H=diag(1,length(X))

# 反復計算回数
ite=10000

# 最小点から非常にかけ離れた点になるのを防ぐためのスカラ
eta=10^(-3)

for(l in 1:ite){
  # 各代数方程式の値が入ったベクトル
  f_val=f(X)

  # 座標点に対する更新量ベクトル
  sigma=t(t(-H%*%f_val))

  # etaによって学習幅を設定し座標点を更新
  X=X+eta*sigma

  # 以前の座標点と更新された座標点の関数値の差のベクトル(y)
  y=f(X)-f_val

  # ヘッシアンの逆行列の近似行列の更新
  H=H+(eta*sigma-H%*%y)%*%t(eta*sigma-H%*%y)/as.numeric(t(y)%*%(eta*sigma-H%*%y))

  print(f(X))
}

# 計算結果から主効果等のパラメータを取り出す
mu=X[1];X=X[-1];alpha=X[1:a];X=X[-c(1:a)];beta=X

pij=array(0,dim=c(a,b))
for(i in 1:a){
  for(j in 1:b){
    pij[i,j]=exp(mu+alpha[i]+beta[j])/(1+exp(mu+alpha[i]+beta[j]))
  }
}
mij_hat=rij*pij

# 尤度比検定の統計量
2*sum(nij*log(nij/mij_hat)+sum((rij-nij)*log((rij-nij)/(rij-mij_hat))))

# 自由度
df=(a-1)*(b-1)

qchisq(1-0.05,df)
